unit tGraf;

interface

type
  vozlisce=class;
  povezava=class
    naslednja: povezava; //naslednja povezava
    kam: vozlisce; //do katerega vozlisca je povezava
    dolzina: real; //dolzina povezave
  end;
  vozlisce=class
    naslednje: vozlisce; //naslednje vozlisce
    prvaPov: povezava; //prva povezava (urejene so kot linearni seznam)
    destructor destroy; override;
    function dodajPov (kam: vozlisce; dolzina: real): boolean; //doda povezavo dolzine <dolzina> do vozlisca <kam>; vrne false, ce povezava ze obstaja, sicer true
    function brisiPov (kam: vozlisce): boolean; //brise povezavo do vozlisca <kam>; vrne false, ce povezava ne obstaja, sicer true
  end;
  graf=class
    prvoVoz: vozlisce; //prvo vozlisce (urejena so kot linearni seznam)
    destructor destroy; override;
    procedure dodajVoz (voz: vozlisce); //doda vozlisce <voz>
    procedure brisiNVoz (voz: vozlisce); //brise naslednje vozlisce od <voz>; ce <voz>=nil, brise prvo vozlisce
  end;

implementation

destructor vozlisce.destroy;
  var pov: povezava;
begin
  if prvaPov<>nil then
    while prvaPov<>nil do begin //gre po vseh povezavah
      pov:=prvaPov;
      prvaPov:=prvaPov.naslednja;
      pov.free; //sprosti trenutno
    end;
  inherited;
end;

function vozlisce.dodajPov (kam: vozlisce; dolzina: real): boolean;
  var pov: povezava;
begin
  pov:=prvaPov;
  while (pov<>nil) and (pov.kam<>kam) do pov:=pov.naslednja; //pregleda, ce povezava ze obstaja
  if pov=nil then begin //ce ne obstaja, jo doda
    pov:=povezava.create;
    pov.kam:=kam;
    pov.dolzina:=dolzina;
    pov.naslednja:=prvaPov;
    prvaPov:=pov;
    dodajPov:=true;
  end else dodajPov:=false;
end;

function vozlisce.brisiPov (kam: vozlisce): boolean;
  var pov1, pov2: povezava;
begin
  brisiPov:=false;
  pov1:=prvaPov;
  if pov1<>nil then
    if pov1.kam=kam then begin //ce ja iskana povezava prva, jo zbrise
      prvaPov:=prvaPov.naslednja;
      pov1.free;
      brisiPov:=true;
    end else begin //ce ni, je treba ravnati drugace
      while (pov1.naslednja<>nil) and (pov1.naslednja.kam<>kam) do pov1:=pov1.naslednja; //gre po vseh povezavah
      if pov1.naslednja<>nil then begin //ce najde iskano, jo zbrise
        pov2:=pov1.naslednja;
        pov1.naslednja:=pov2.naslednja;
        pov2.free;
        brisiPov:=true;
      end;
    end;
end;

destructor graf.destroy;
  var voz: vozlisce;
begin
  if prvoVoz<>nil then
    while prvoVoz<>nil do begin //gre po vseh vozliscih
      voz:=prvoVoz;
      prvoVoz:=prvoVoz.naslednje;
      voz.free; //sprosti trenutno
    end;
  inherited;
end;

procedure graf.dodajVoz (voz: vozlisce);
begin
  voz.naslednje:=prvoVoz; //doda na zacetek
  prvoVoz:=voz;
end;

procedure graf.brisiNVoz (voz: vozlisce);
  var voz1: vozlisce;
begin
  voz1:=prvoVoz;
  while voz1<>nil do begin //gre po vseh vozliscih
    if voz=nil then voz1.brisiPov (prvoVoz) else voz1.brisiPov (voz.naslednje); //zbrise povezavo od trenutnega do brisanega
    voz1:=voz1.naslednje;
  end;
  if voz=nil then begin //ce <voz>=nil, brise zbrise prvo vozlisce
    prvoVoz:=prvoVoz.naslednje;
    voz1.free;
  end else begin //sicer zbrise naslednjega od <voz>
    voz1:=voz.naslednje;
    voz.naslednje:=voz1.naslednje;
    voz1.free;
  end;
end;

end.
